<template>
  <div>
    <div>
<CModal
          title="Info"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>

<CCardBody>
     <h5>Trace Anchor Tag WC Mapping</h5>
   
     <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="5"
      pagination
      hover
      striped
      border  
     >
   

<!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >
      <CButton size="sm" color="info" class="ml-1"  @click="ShowUpdateModal=true; SelectAnchorTagWCMapping(item)"> Update </CButton>
      <CButton size="sm" color="danger" class="ml-1" @click="ShowDeleteModal=true; SelectAnchorTagWCMapping(item)" >Delete</CButton>
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectAnchorTagWCMapping(item)"> Details </CButton>
    </template>

    </CDataTable>
      <CButton size="sm" color="info" class="" @click="ShowAddModal=true"> Add Anchor Tag WC Mapping</CButton>
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Add New Mapping</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-7">
<form action="#" method="POST">

<div class="form-group">
  <label for="WC_Id">WC </label>
 <select class="form-control"   v-model="newMapping.workCent_Id" >
    <option value="" selected disabled>Select WC</option>
    <option v-for="item in WCitems" :value="item.workCent_Id" :key="item.workCent_Id">{{ item.workCent_Name }}</option>
  </select>
</div>

<div class="form-group">
    <label for="Anchor_Tag_Id">Anchor Tag</label>
 <select class="form-control"   v-model="newMapping.uwB_Anchor_Id" >
    <option value="" selected disabled>Select Tag</option>
    <option v-for="item in Anchortagitems" :value="item.uwB_Anchor_Id" :key="item.uwB_Anchor_Id">{{ item.uwD_Anchor_Name }}</option>
  </select>
</div>

<!-- <div class="form-group">
<input type="text" name="Anchor_Tag_Status" class="form-control form-control-lg" placeholder="AnchorTag Anchor_Tag_Status"  v-model="newAnchorTag.Anchor_Tag_Status">
</div> -->

<div class="form-group">
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;addAnchorTagWCMapping();" > Add Anchor Tag WC Mapping</CButton>
</div>

</form>
 </div>
</div>
</div>
 </div>

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Anchor Tag Details</h5>
    <button type="button" class="close"  @click="ShowDetailsModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body p-4">

<form action="#" method="POST">
<div class="form-group"> <label for="Anchor_Tag_Id">ID </label>
<input type="text" name="Anchor_Tag_Id" readonly class="form-control form-control-sm" placeholder="Anchor Tag Id" v-model="CurrentAnchorTagWCMapping.Anchor_Tag_Id">
</div>

<div class="form-group"> <label for="WC_Id">Anchor Tag Name </label>
<input type="text" name="Anchor_Tag_Name" readonly class="form-control form-control-sm" placeholder="Anchor Tag Name" v-model="CurrentAnchorTagWCMapping.Anchor_Tag_Name">
</div>

<div class="form-group"> <label for="WC_Id">WC </label>
<input type="text" name="Anchor_Tag_Uniqe_Id" readonly class="form-control form-control-sm" placeholder="Anchor Tag Uniqe Id" v-model="CurrentAnchorTagWCMapping.Anchor_Tag_Uniqe_Id">
</div>


<!-- <div class="form-group">
<input type="text" name="Anchor_Tag_Status" readonly class="form-control form-control-lg" placeholder="AnchorTag Anchor_Tag_Status"  v-model="newAnchorTag.Anchor_Tag_Status">
</div> -->

<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowDetailsModal=false;" > Close </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update AnchorTag</h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">
<!-- <div class="form-group">
<input type="text" name="Anchor_Tag_Id" class="form-control form-control-lg" placeholder="Anchor Tag Id" v-model="newAnchorTag.Anchor_Tag_Id">
</div> -->

<div class="form-group">
<input type="text" name="Anchor_Tag_Name" class="form-control form-control-sm" placeholder="Anchor Tag Name" v-model="CurrentAnchorTagWCMapping.uwB_Anchor_Id">
</div>

<div class="form-group">
<input type="text" name="workCent_Id" class="form-control form-control-sm" placeholder="workCent_Id" v-model="CurrentAnchorTagWCMapping.workCent_Id">
</div>


<!-- 
<div class="form-group">
<input type="text" name="Anchor_Tag_Status" class="form-control form-control-lg" placeholder="AnchorTag Anchor Tag Status"  v-model="CurrentAnchorTagWCMapping.Anchor_Tag_Status">
</div> -->

<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowUpdateModal=false;UpdateAnchorTagWCMapping();" > Update AnchorTag </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete AnchorTag</h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the AnchorTag ? </h4>
<h5> You are deleting {{ this.CurrentAnchorTagWCMapping.Anchor_Tag_Id +' || '+ this.CurrentAnchorTagWCMapping.Anchor_Tag_Name }}</h5>
<hr>
<button class="btn btn-danger btn-lg" @click="ShowDeleteModal=false; deleteItem();getAllAnchorTagWCMappingDetails()  "> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-lg" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>

<script>

const items = [
  { key: 'id', _style:'min-width:200px' },
  { key: 'uwB_Anchor_Id', _style:'min-width:100px;' },
  { key: 'workCent_Id', _style:'min-width:50px;' },   
  { key: 'assign_date',     _style: 'width:1%' },
 ]   
const apiget =  'Trace_Anchor_Workcenter_Mapping/'
//import CTableWrapper from '.@/Table.vue' 
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)
 
export default {
  
  data ()
  {
    return {
    items: items.map((item, id) => { return {...item, id}}),
    
     fields: [
              { key: 'id' , label: 'Id',_classes: 'font-weight-bold'},
              { key: 'uwB_Anchor_Id', label: 'Anchor Id',_classes: 'font-weight-bold' },
              { key: 'workCent_Id', label: ' Work Center Id', _classes: 'font-weight-bold' },
              { key: 'assign_date',  label: 'Installed Date',  _style: 'width:12%', },
              { key: 'show_details',  label: '',  _style: 'width:30%', },           
      ],
  details: [],
  collapseDuration: 0,
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentAnchorTagWCMapping:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
  WCitems:"",
  Anchortagitems:"",
  newMapping: {id:0,uwB_Anchor_Id:0,workCent_Id:0,assign_date:new Date(),status:1}, }
  },
 

  
  mounted()
  {
   this.getAllAnchorTagWCMappingDetails();
   this.getAllWCDetails();
   this.getAllAnchorDetails();
  },

  methods:
  {
   getAllAnchorTagWCMappingDetails: function()
   {

   Vue.axios.get(this.$url+ apiget)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items =response.data.filter(x => x.status == 1);
      

       }
    });
   },
//https://localhost:44348/api/Trace_WC_Master
  getAllWCDetails: function()
   {

   Vue.axios.get(this.$url+ 'Trace_WorkCenter_Master/')
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.WCitems =response.data.filter(x => x.status == 1);
      

       }
    });
   },
   //
  getAllAnchorDetails: function()
   {
 //alert(this.$url+ 'Trace_UWB_Anchor_Master/');
   Vue.axios.get(this.$url+ 'Trace_UWB_Anchor_Master/')
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.Anchortagitems =response.data.filter(x => x.uwD_Anchor_Status == 1);
      

       }
    });
   },
  addAnchorTagWCMapping()
  {
     
    Vue.axios.post(this.$url+ apiget,this.newMapping).then((response)=>{
      
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
        this.SuccessMsg ="Records Inserted Successfully.."
        this.getAllAnchorTagWCMappingDetails();
       }
    })
   },

  UpdateAnchorTagWCMapping()
  {
 Vue.axios.put(this.$url+ apiget+this.CurrentAnchorTag.Anchor_Tag_Id,this.CurrentAnchorTag,).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
         this.SuccessMsg ="Records Updated Successfully.."
         this.getAllAnchorTagDetails();
       }
    })
   },

  deleteItem()
    {
      var Anchor_Tag_Id = this.CurrentAnchorTag.Anchor_Tag_Id;
        axios({   method: 'delete',
           url: this.$url+ apiget+ Anchor_Tag_Id
    });
        this.SuccessMsg="WCMapping Status Changed to Inactive Succesfully"
    },
      
  SelectAnchorTagWCMapping(AnchorTagWCMapping)
    {
     this.CurrentAnchorTagWCMapping=AnchorTagWCMapping;
    },
    
  
    
    },
  
    

}
</script>

<style scoped>
#overlay{
  position:fixed;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>